""" 
miPapelera - modificacion y traduccion por Fernando Briano - www.picandocodigo.net de:

KDE Trash
Copyright (C) xapek.org

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
"""
import karamba
import os


def getPath():
	prefix = os.path.dirname(__file__)
	if (prefix):
		return  prefix + "/"
	else:
		return os.getcwd() + "/"

class Trash:
	selectmenu = 0
	check = ""
	trash_dir = os.path.expandvars('$HOME') + "/.local/share/Trash/files/"
	path = getPath()
	"""Init Widget"""
	def init(self, widget):
                """self.bg = karamba.createImage(widget, 0, 0, 'bg.png')"""
		self.text = karamba.createText(widget, 0, 70, 100, 20, "")
		self.selectmenu = karamba.createMenu(widget)
		prefix = os.path.dirname(__file__)
		self.trash_menu = {
			karamba.addMenuItem(widget,self.selectmenu, "Abrir papelera", self.path + "images/icon_open.png") : self.openTrash,
			karamba.addMenuItem(widget, self.selectmenu, "Vaciar papelera", self.path + "images/icon_empty.png") : self.emptyTrash
			}
		self.update(widget)
                
	"""Update Widget"""
	def update(self, widget):
		size = len( os.listdir(self.trash_dir) )
		if size == 0:
			karamba.changeText(widget, self.text, "")
			if (self.check != "vacia"):
				try:
					karamba.deleteImage(widget, self.trash)
				except:
					pass
                                
				self.trash = karamba.createImage(widget, 0, 0, 'images/trash_empty.png')
				self.check = "empty"
		else: #size > 0 -> show Number of files in trash
			if size == 1:
                        	karamba.changeText(widget, self.text, str(size) + " Elemento  ")
                        else:
                        	karamba.changeText(widget, self.text, str(size) + " Elementos ")
                        
			self.prettyText(widget, self.text, size)
			if (self.check != "full"):
				try:
					karamba.deleteImage(widget, self.trash)
				except:
					pass
                                
				self.trash = karamba.createImage(widget, 0, 0, 'images/trash_full.png')
				self.check = "full"
	"""Menu Click"""
	def menuItemClicked(self, id):
		if self.trash_menu[id]:
			self.trash_menu[id]() #Execute above defined method
	"""Set pretty text"""
	def prettyText(self, widget,text,size):
		karamba.changeTextFont(widget, text, "arial black")
		if size >= 1000: #Code Red :)
			karamba.changeTextColor(widget, text, 255, 0, 0)
		karamba.changeTextSize(widget, text, 10)
	def itemDropped(self, url):
		karamba.execute("kfmclient move '" + str(url) + "' trash:/")
	def emptyTrash(self):
		karamba.execute('ktrash --empty')
	def openTrash(self):
		karamba.execute('konqueror trash:/')

object = Trash()

def initWidget(widget):
	global object
	karamba.acceptDrops(widget)
	object.init(widget)
	object.update(widget)

def widgetClicked(widget,x,y,button):
	global object
	karamba.popupMenu(widget, object.selectmenu, x, y)

def menuItemClicked(widget,menu,id):
	object.menuItemClicked(id)

def widgetUpdated(widget):
	global object
	object.update(widget)
	
#old SK
def itemDropped(widget, url, unused, unused2):
	global object
	object.itemDropped(widget, url)
	
#new SK
def itemDropped(widget, url):
	global object
	object.itemDropped(url)
	object.update(widget)

print "KDE Garbage loaded"
